<template>
    <div class="step2">
        <div>2 крок. Вибір вчителів.</div>
    </div>
    <div>
        <div v-for="lesson in filteredLessons" :key="lesson.code">
            <label>{{ lesson.subject }}</label>
            <select v-model="selectedTeachers[lesson.code]">
                <option v-for="teacher in getAllTeachersForSubject(lesson.subject)" :key="teacher.code"
                    :value="teacher.name">
                    {{ teacher.name }}
                </option>
            </select>
        </div>

        <div>
            <button @click="submitSelection">Розпочати навчання</button>
        </div>
    </div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
    name: 'LessonsList',
    data() {
        return {
            selectedTeachers: {},
        };
    },
    computed: {
        ...mapGetters(['getAllLessons', 'getAllTeachers']),
        filteredLessons() {
            const selectedLessonIds = (this.$route.params.id || []).map(id => Number(id));
            return this.getAllLessons.filter(lesson => selectedLessonIds.includes(lesson.code));
        },
    },
    methods: {
        submitSelection() {
            // console.log('Selected Teachers:', this.selectedTeachers);
            const selectedPairs = Object.entries(this.selectedTeachers).map(([lessonId, teacherName]) => {
                const teacher = this.getAllTeachers.find(t => t.name === teacherName);
                const teacherId = teacher ? teacher.code : null;
                return `${lessonId}-${teacherId}`;
            });

            const newUrl = `/lessons/${selectedPairs.join('/')}`;
            this.$router.push(newUrl);
        },
        getAllTeachersForSubject(subject) {
            return this.getAllTeachers.filter(teacher => teacher.subject === subject);
        },
    },
};
</script>

<style lang="scss" scoped>
.step2 {
    color: red;
}
</style>